#include "exodecrunch.h"
#include <stdio.h>
#include <stdlib.h>

unsigned char windowoutput[65536];

static int read_byte(void *read_data)
{
    FILE *in;
    int c;

    in = (FILE*)read_data;
    c = fgetc(in);

    return c;
}

int main(int argc, char *argv[])
{
    FILE *in;
//    FILE *out;
    FILE *outopt;
    struct exo_decrunch_ctx *ctx;
    int c;
    int bytes,offset;

    if(argc != 3)
    {
        fprintf(stderr, "Error: usage: %s <infile> <outfile>\n", argv[0]);
        exit(-1);
    }
    in = fopen(argv[1], "rb");
    if(in == NULL)
    {
        fprintf(stderr, "Error: can't open %s for input.\n", argv[1]);
        exit(-1);
    }
//    out = fopen(argv[2], "wb");
//    if(out == NULL)
//    {
//        fprintf(stderr, "Error: can't open %s for output.\n", argv[2]);
//        exit(-1);
//    }

    outopt = fopen(argv[2], "wb");
    if(outopt == NULL)
    {
        fprintf(stderr, "Error: can't open %s for optimized output.\n", argv[2]);
        exit(-1);
    }

    ctx = exo_decrunch_new(MAX_OFFSET, read_byte, in);

    while((c = exo_read_decrunched_byte(ctx)) != EOF)
    {
        // fputc(c, out);
    }
    
    exo_write_output(ctx,outopt);
    exo_decrunch_delete(ctx);

    fclose(outopt);
//    fclose(out);
    fclose(in);

    return 0;
}
